Doomsday Engine - Bug #1894

[Heretic] Map that relies on original footclipping
2014-11-04 00:29 - vermil

Status: New Start date: 2014-11-04
Priority: Normal % Done: 0%
Assignee:

Category: Vanilla emulation

Target version: Vanilla / Gameplay

Description

E1M2 of this Heretic pwad relies on the original games buggy foot clipping in order for the player to be able to pick up the Blue Key.

http://www.doomworld.com/idgames/index.php?file=levels/heretic/a-c/aquaduct.zip

In Vanilla Heretic, footclipping occurred as soon as the players mid point moved over a sector with an appropriate flat.

Dday sometime in the 1.9 series, changed this behaviour so that the player had to actually touch the appropriate flat before
footclipping occurred.

History

#1 - 2014-11-04 10:45 - skyjake

- Category set to Vanilla emulation

#2 - 2014-11-04 11:07 - danij

Foot-clipping should not actually matter here, as its a visual effect only. Needs investigating further.

#3 - 2014-11-04 11:08 - danij
- Tags set to Heretic, PlaySim

#4 - 2014-11-04 12:10 - vermil

GZDoom also appears to have the same issue with the blue key on this map. Dday 1.8.6 can't actually load this map for some reason (it seg faults).
In Vanilla Heretic, the player can grab the key.

It is possible to pick up the key in Dday by saving a save game on top of it and then loading it. This is due to the vanilla bug that upon loading a save

game, all mobjs are considered in the sector their centre is over and hence may fall down upon loading (i.e this includes the player mobj, which may
lead to them falling through the world and hence becoming stuck). Dday retains this bug, but GZDoom fixes it.

#5 - 2014-11-04 13:03 - danij

I'm not sure what you mean by "vanilla bug that upon loading a save game, all mobjs are considered in the sector their centre is over" - this should
always be the case. What is there to fix?

Edit: Maybe you are referring to the sector assigned to the BSP leaf at the mobj's origin rather than the sector in which that mobj resides? If so then
this would suggest the mobj is picking up things before its even been linked into the map in vanilla.

#6 - 2014-11-04 23:56 - vermil

danij wrote:
I'm not sure what you mean by "vanilla bug that upon loading a save game, all mobjs are considered in the sector their centre is over" - this
should always be the case. What is there to fix?

| was just providing that as extra information, rather than reporting it as a bug | was expecting to be fixed.

Currently, Dday replicates vanilla with this; when a sector raises/lowers, mobjs are lifted based off their entire hitbox. But when one loads a save
game, mobjs drop down to the sector their centre is over.

Though it does cause a bit of annoyance when it happens with player mobjs.

#7 - 2014-11-05 00:08 - danij

Thanks for the clarification. That explains a lot (why it works in vanilla, is fixed in dday when not loading a save, and fixed in GZDoom which has to
http://www.doomworld.com/idgames/index.php?file=levels/heretic/a-c/aquaduct.zip

work like this because of 3D floors).

#8 - 2014-11-05 10:23 - vermil

danij wrote:

Thanks for the clarification. That explains a lot (why it works in vanilla, is fixed in dday when not loading a save, and fixed in GZDoom which has
to work like this because of 3D floors).

Certainly yes, the key does just overlap the raised edge of the water stream, but is always found down in it, in Vanilla, Dday and GZDoom, due to the
bug where mobjs are spawned based on the sector their centre lay's in.

But that doesn't explain why the player can still pick up the key in vanilla and not Dday or GZDoom. | did originally believe the player happened to pick
up the key at the same moment footclipping occurred in vanilla. But upon retesting, the player can easily pick up the key long before footclipping
occurs.

EDIT: I've just made my own test map with a key down a 64x64, 24 unit deep (bare in mind that the key mobj's are only 16 high), hole and the player

does seem to be able to grab the key slightly earlier in vanilla than Dday. In Vanilla they can clearly grab the key without going into the hole, but in
Dday they seem to have to fall into the hole or run over it.

#9 - 2017-04-03 14:06 - skyjake

- Target version set to Modding

#10 - 2017-04-03 18:33 - skyjake

- Target version changed from Modding to Vanilla/ Gameplay
